<!-- 监控日志 -->
<template>
  <div class="app-container monitorLog">
    <div class="page-container monitorLogPage" v-if="pageType === 1">
      <div class="page-form-title-box">
        <el-form :model="queryParams" class="form-box" ref="queryForm"
                 :inline="true" style="width:100%;">
          <el-form-item label="" prop="searchValue">
            <el-input
              maxLength="30"
              v-model="queryParams.searchValue"
              placeholder="请输入设备名称"
              style="width: 200px"
            />
          </el-form-item>
          <el-form-item label="" prop="typeKey">
            <el-select v-model="queryParams.typeKey" placeholder="请选择设备分类" style="width: 200px">
              <el-option
                v-for="dict in typeOptionList"
                :key="dict.typeKey"
                :label="dict.typeName"
                :value="dict.typeKey"
              />
            </el-select>
          </el-form-item>
          <el-form-item label="" prop="state">
            <el-select v-model="queryParams.state" placeholder="请选择状态" style="width: 200px">
              <el-option
                v-for="dict in optionList"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              />
            </el-select>
          </el-form-item>
          <el-form-item label="" prop="state">
            <el-date-picker
              :clearable="false"
              v-model="dateRange"
              size="small"
              style="width: 240px"
              value-format="yyyy-MM-dd"
              type="daterange"
              range-separator="-"
              start-placeholder="开始日期"
              end-placeholder="结束日期"
            ></el-date-picker>
          </el-form-item>
          <p class="page-inquire-common-style-button" @click="handleQuery">查询</p>
          <p class="page-reset-common-style-button" @click="resetQuery">重置</p>
        </el-form>
      </div>
      <div class="page-content-box">
        <el-table class="table-box" v-loading="loading" border :data="dataList">
          <el-table-column label="设备名称" prop="deviceName"  show-overflow-tooltip/>
          <el-table-column label="位置" prop="content" width="400" show-overflow-tooltip>
            <template slot-scope="scope">
              <span>{{scope.row.schoolName}}-{{scope.row.buildName}}-{{scope.row.floorName}}</span>
            </template>
          </el-table-column>
          <el-table-column label="描述" prop="checkDesc" width="300" show-overflow-tooltip/>
          <el-table-column label="状态" prop="state" width="150" show-overflow-tooltip>
            <template slot-scope="scope">
              <span>{{scope.row.state?'正常':'异常'}}</span>
            </template>
          </el-table-column>
          <el-table-column label="告警" prop="content" width="150" show-overflow-tooltip>
            <template slot-scope="scope">
              <span>{{scope.row.alarmState == 0?'N/A':(scope.row.alarmState == 1?'告警成功':(scope.row.alarmState == 2?'告警失败':''))}}</span>
              <span v-if='scope.row.alarmState != 0'
                    style="margin-left:20px;cursor: pointer;font-size:18px;color:#0183FA;"
                    class="el-icon-tickets"
                    @click="lookInfo(scope.row.alarmDesc)"></span>
            </template>
          </el-table-column>
          <el-table-column label="时间" prop="createTime" width="200" show-overflow-tooltip>
            <template slot-scope="scope">
              <span>{{ parseTime(scope.row.createTime,"{y}-{m}-{d} {h}:{i}") }}</span>
            </template>
          </el-table-column>
        </el-table>
        <pagination :page-sizes="[20, 30, 40, 50]"
                    v-show="total>0"
                    :total="total"
                    :page.sync="queryParams.page"
                    :limit.sync="queryParams.pageSize"
                    @pagination="getList"
        />
      </div>
    </div>
    <public-log-dialog ref="publicLogDialog"></public-log-dialog>
  </div>
</template>
<script>
  import publicLogDialog from '@/components/publicLogDialog/publicLogDialog.vue'
  import { iotMonitorLogList,iotTypeGetAllTypes } from "@/api/iotDevice/index";
  export default {
    name: 'index',
    components: {
      publicLogDialog
    },
    data () {
      return {
        tableButtonType:this.hasPermiDom(['demo:demo:detail','demo:demo:edit','demo:demo:del',]),
        //页面状态
        pageType:1,
        //页面遮罩
        loading:false,
        //下拉列表数据
        typeOptionList:[],
        optionList:[{value:true,label:'正常'},{value:false,label:'异常'}],
        //查询条件
        queryParams:{
          page:1,
          pageSize:20,
          searchValue:"",
          typeKey:null,
          state:null,
        },
        //时间数据
        dateRange:[],
        //列表数据
        dataList:[],
        //数据数量
        total:0,
        //组件传参
        propsData:{},
      }
    },
    created () {

    },
    mounted () {
      this.getList();
      this.iotTypeGetAllTypes();
    },
    methods: {
      lookInfo(text){
        this.$refs.publicLogDialog.publicLogDialogOpen(text);
      },
      //查询按钮
      handleQuery(){
        this.$set(this.queryParams,'page',1);
        this.getList();
      },
      //重置按钮
      resetQuery(){
        this.$set(this,'dateRange',[])
        this.$set(this,'queryParams',{
          page:1,
          pageSize:20,
          searchValue:"",
          typeKey:null,
          state:null,
        });
        this.getList();
      },
      //获取数据列表
      getList(){
        this.$set(this,'loading',true);
        let obj = JSON.parse(JSON.stringify(this.queryParams))
        if(this.dateRange[0]){
          obj.startTime = this.dateRange[0]+'T00:00:00'
          obj.endTime = this.dateRange[1]+'T23:59:59'
        }else{
          obj.startTime = "";
          obj.endTime = "";
        }
        iotMonitorLogList(obj).then(response => {
          this.$set(this,'loading',false);
          this.$set(this,'dataList',response.data.records);
          this.$set(this,'total',response.data.total);
        });
      },
      //操作按钮
      tableButton(type,row){
        let self = this;
        if(type == 1){
          //新增
          this.$set(this,'pageType',2);
          this.$set(this,'propsData',{});
        }else if(type == 2){
          //详情
          this.$set(this,'pageType',2);
          let obj = JSON.parse(JSON.stringify(row))
          obj.showType = true;
          this.$set(this,'propsData',obj);
        }else if(type == 3){
          //编辑
          this.$set(this,'pageType',2);
          let obj = JSON.parse(JSON.stringify(row))
          obj.showType = false;
          this.$set(this,'propsData',obj);
        }else if(type == 4){
          //删除
          this.$confirm('是否确认删除?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
          }).then(() => {
            deleteFunction({id:row.id}).then(response => {
              self.msgSuccess(response.message)
              self.getList();
            });
          }).catch(() => {});
        }else if(type == 5){
          //启用&停用
          let text = row.state  ? "停用" : "启用";
          this.$confirm('是否确认' + text + '?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
          }).then(() => {
            stateFunction({id:row.id,state:!row.state,}).then(response => {
              self.msgSuccess(response.message)
              self.getList();
            });
          }).catch(() => {});
        }else if(type == 6){
          //返回并刷新
          this.$set(this,'pageType',1);
          this.getList();
        }
      },
      //获取设备分类列表
      iotTypeGetAllTypes(){
        iotTypeGetAllTypes({}).then(response => {
          this.$set(this,'typeOptionList',response.data);
        });
      },
    },
  }
</script>
<style scoped lang="scss">
  .monitorLog{
    .monitorLogPage{

    }
  }
</style>
